import { RefObject } from 'react';
import { SpringValue } from 'react-spring';
interface UseStepsProps {
    stepsRef: RefObject<HTMLElement>[];
    wrapperRef?: RefObject<HTMLElement>;
    offset?: {
        x: number;
        y: number;
    };
    queueTime?: number;
    getPositionsAwaitTime?: number;
}
interface StepAnimationData {
    animationProps: {
        top: SpringValue<number>;
        left: SpringValue<number>;
    };
    step: number;
    stepsPositions: {
        x: number;
        y: number;
    }[];
    nextStep: () => void;
    previousStep: () => void;
}
export declare const useStepAnimation: ({ stepsRef, wrapperRef, offset, queueTime, getPositionsAwaitTime, }: UseStepsProps) => StepAnimationData;
export {};
