"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useWindowSize = function () {
    var isSSR = typeof window === 'undefined';
    var _a = (0, react_1.useState)({
        width: isSSR ? 1200 : window.innerWidth,
        height: isSSR ? 800 : window.innerHeight,
    }), windowSize = _a[0], setWindowSize = _a[1];
    (0, react_1.useEffect)(function () {
        var changeWindowSize = function () {
            setWindowSize({ width: window.innerWidth, height: window.innerHeight });
        };
        window.addEventListener('resize', changeWindowSize);
        return function () { return window.removeEventListener('resize', changeWindowSize); };
    }, []);
    return windowSize;
};
exports.default = useWindowSize;
